// Data East rotary joystick handle (balltop replacement) V0.01
// -- Handle top

// Other prints needed:
// -- Test print
// -- Test print2
// -- Handle
// -- Eject pin (2 pins per handle)

// Logo exported from Inkscape to .dxf file using https://github.com/brad/Inkscape-OpenSCAD-DXF-Export

/////////////////////////////
//  Adjustable variables
/////////////////////////////

// Logo
    LogoDepth = 1; // Default = 1.0
    // Logo depth in the main body

// Body
    TopHeight = 2; // Default = 2
    // Height of the body

    TopDiameter = 29.2; // Default = 29.2
    // Diameter of the body that fits inside the handle

    TopWiggleRoom = 0.65; // Default = 0.65
    // Amount to decrease the body diameter for easier insertion/removal of top.  It also allows for the 180-sided polygon used to render circles -- see "undersized holes" at https://en.wikibooks.org/wiki/OpenSCAD_User_Manual/Primitive_Solids#cylinder

    TopTaper = 0.2; // Default = 0.2
    // Amount to reduce the bottom diameter of the body

// Number of fragments (polygon sides) used to render a full circle.
    $fn = 180; // Default = 180  Typical range = 6 - 360
    // 6 will render a circular hole as a hexagon, 8 will render a circular hole as an octagon.
    // Lower the number for faster rendering, raise the number for smoother rendering.


/////////////////////////////
//  Make the part
/////////////////////////////

difference(){ // Body minus DE logo
    // Body
    translate ([TopDiameter/2, TopDiameter/2, TopHeight/2]) cylinder (TopHeight, d1 = TopDiameter - TopTaper - TopWiggleRoom, d2 = TopDiameter - TopWiggleRoom, center=true);
    //

    // DE Logo (Optional)
    // Comment out the next three lines to skip the logo
    translate([0, 0, TopHeight-LogoDepth+0.01])
    resize(newsize=[TopDiameter ,TopDiameter ,LogoDepth])
    linear_extrude(height = LogoDepth, convexity = 10)
    import(file = "DE_Logo.dxf", layer="Logo");
    // The "DE_Logo.dxf" file needs to be in the same directory as this SCAD file.
}
//